<template>
  <div v-if="album && user">
    <PageTemplate
      type="album"
      :data="album"
      @onEdit="modals.edit = !modals.edit"
      @onDelete="modals.delete = true"
      @onPrivate="updateItemPrivate"
      @onShare="modals.share = !modals.share"
    />

    <el-upload :onUpload="onUploadPhoto" multiple />

    <Feed
      v-if="media.length"
      v-loading="loading"
      :data="media"
      :counter="true"
      :moderate="true"
    />

    <portal to="modal">
      <Modal v-model="modals.share">
        <template slot="title">Share link</template>
        <ShareModal :url="`album/${album.id}`" />
      </Modal>

      <Modal v-model="modals.edit">
        <template slot="title">Edit album</template>
        <template slot="bottom">
          <Button size="small" @click="updateItem">
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>

        <div class="modal__input is-active">
          <span class="modal__label">Album name</span>
          <el-input border line v-model="album.name" />
        </div>
        <div class="modal__input is-active">
          <span class="modal__label">Description</span>
          <el-input
            type="textarea"
            :autosize="{ minRows: 1, maxRows: 6 }"
            border
            line
            v-model="album.comment"
          />
        </div>

        <div
          class="modal__input"
          @click="modals.map = true"
          :class="{ 'is-active': album.location }"
        >
          <span class="modal__label">Location</span>
          <el-input
            border
            line
            ref="input_location"
          />
        </div>

        <div class="modal__input">
          <span class="modal__label">Tags</span>
          <el-input border line />
        </div>

        <div v-if="album.tags">
          <div :key="tagIndex" v-for="(item, tagIndex) in album.tags">
            <el-tag
              :disable-transitions="false"
              @close="removeTags(item)"
              closable
              effect="dark"
            >
              <span>{{ item.tag.tag }}</span>
            </el-tag>
          </div>
        </div>

        <div
          v-for="(item, index) in album.payment_types"
          :key="index"
          class="modal__grid"
        >
          <div v-if="userPayment">
            <div
              class="modal__input"
              :class="{ 'is-active': item.payment_type }"
            >
              <span class="modal__label">Payment type</span>
              <el-select border line v-model="item.payment_type">
                <el-option
                  v-for="item in userPayment"
                  :key="item.id"
                  :value="item.payment_type"
                >
                  {{ item.payment_type }}
                </el-option>
              </el-select>
            </div>
          </div>
          <div>
            <div class="modal__input" :class="{ 'is-active': item.price }">
              <span class="modal__label">Price</span>
              <el-input v-model="item.price" border line />
            </div>
          </div>
          <button
            v-if="album.payment_types.length > 1"
            @click="removePayment(item)"
          >
            delete
          </button>
        </div>

        <AddPayment
          v-if="
            album.payment_types &&
            album.payment_types.length !== user.payment_types.length
          "
        />

        <Map
          v-if="modals.map"
          :data="album.location || user.location"
          type="edit"
          @closeMap="modals.map = false"
          :onCreate="onCreateLocation"
        />
      </Modal>
    </portal>

    <el-dialog title="Warning" :visible.sync="modals.delete" center>
      It should be noted that the content will not be aligned in center by
      default
      <template slot="footer">
        <Button
          size="small"
          variant="white-opacity"
          @click="modals.delete = false"
        >
          {{ $t('buttons.cancel') }}
        </Button>
        <Button size="small" variant="success" @click="deleteItem">
          {{ $t('buttons.delete') }}
        </Button>
      </template>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  computed
} from '@nuxtjs/composition-api'

import {
  useGetAlbumQuery,
  useUpdateAlbumMutation,
  useDeleteAlbumMutation,
  useMediaSubscription,
  useCreateLocationMutation
} from '@/sdk/hooks'
import { AlbumFragment, MediaFileFragment } from '@/sdk/types'
import { pick, mergeWith } from 'lodash'

import PageTemplate from '@/components/template/PrivatePage.vue'
import elInput from '@/components/element/Input.vue'
import elCheckbox from '@/components/element/Checkbox.vue'
import elCheckboxGroup from '@/components/element/CheckboxGroup.vue'
import elDialog from '@/components/element/Dialog.vue'
import elTag from '@/components/element/Tag.vue'
import elUpload from '@/components/element/Upload.vue'

import Feed from '@/components/ui/Feed.vue'
import AddPayment from '@/components/ui/AddPayment.vue'
import Button from '@/components/ui/Button.vue'
import Modal from '@/components/ui/Modal.vue'
import Map from '@/components/ui/Map.vue'
import ShareModal from '@/components/modal/ShareModal.vue'

export default defineComponent({
  name: 'PrivateAlbumPage',
  components: {
    PageTemplate,
    Feed,
    Modal,
    AddPayment,
    Button,
    elInput,
    elUpload,
    elCheckbox,
    elCheckboxGroup,
    elDialog,
    elTag,
    ShareModal,
    Map
  },
  setup(_, { root }) {
    const { app } = useContext()
    const user = computed(() => root.$accessor.auth.user)
    const album = ref<AlbumFragment>([] as any)
    const { onResult } = useGetAlbumQuery(
      computed(() => ({
        id: root.$route.params.id as string
      }))
    )
    if (process.client) {
      onResult(result => {
        if (result?.data?.album) {
          album.value = result.data.album
        }
      })
    }

    const modals = ref({
      share: false,
      edit: false,
      map: false,
      delete: false
    })

    // map

    const newLocation = ref()
    const onCreateLocation = (data: any) => {
      modals.value.map = false
      //formData.value.location = data.location_name
      newLocation.value = data
    }

    // edit item
    const { mutate: UpdateItemMutate } = useUpdateAlbumMutation({})
    const { mutate: updateGeo } = useCreateLocationMutation({})
    const updateItem = async () => {
      modals.value.edit = false
      if (newLocation.value) {
        await updateGeo({
          object: {
            id: newLocation.value.id,
            ...newLocation.value.geo,
            geo: {
              type: 'Point',
              coordinates: newLocation.value.coordinates
            }
          }
        })
      }
      await UpdateItemMutate({
        id: root.$route.params.id as string,
        object: {
          ...pick(album.value, ['name', 'comment']),
          location_id:
            newLocation?.value?.id || album.value?.location_id || undefined
        },
        payment: album.value.payment_types.map((r: any) => ({
          album_id: root.$route.params.id,
          payment_type: r.payment_type,
          price: r.price || 0
        })),
        tags: album.value.tags.map((r: any) => ({
          album_id: root.$route.params.id,
          tag_id: r.tag_id
        }))
      })
    }

    // delete item

    const { mutate: DeleteItemMutate } = useDeleteAlbumMutation({})
    const deleteItem = () => {
      DeleteItemMutate({ id: root.$route.params.id as string })
      root.$router.push(`/profile/photography`)
    }

    // change private

    const updateItemPrivate = async () => {
      album.value.private = !album.value.private
      await UpdateItemMutate({
        id: root.$route.params.id as string,
        object: pick(album.value, ['private']),
        payment: [],
        tags: []
      })
    }

    // payment
    const userPayment = mergeWith(
      user.value?.payment_types,
      album.value.payment_types
    )

    // tags

    const removeTags = (item: any) => {
      var index = album.value.tags.indexOf(item)
      if (index !== -1) {
        album.value.tags.splice(index, 1)
      }
    }

    // upload photos && output media
    const pageSize = ref(2000)
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult, loading } = useMediaSubscription(
      computed(() => ({
        where: {
          album_id: { _eq: root.$route.params.id }
        },
        limit: pageSize.value,
        offset: 0
      }))
    )
    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })
    const onUploadPhoto = async (file: File) => {
      try {
        await app.$api.storage.upload(
          `public/web/media/${Date.now()}.jpg`,
          file,
          {
            type: 'album',
            object_id: root.$route.params.id
          }
        )
      } catch (e) {
        console.log(e)
      } finally {
        root.$message({
          message: 'Congrats, this is a success message.',
          type: 'success'
        })
      }
    }

    return {
      user,
      album,
      media,
      updateItemPrivate,
      deleteItem,
      updateItem,

      modals,
      onUploadPhoto,
      onCreateLocation,

      loading,
      userPayment,
      removeTags
    }
  }
})
</script>
